/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
var XYChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XYChart, _super);
    function XYChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.v6 = null;
        _this.v7 = null;
        _this.wn = 0;
        _this.wp = 5;
        _this.wo = 0;
        _this.wm = 5;
        _this.w4 = 5;
        _this.w6 = 0;
        _this.w5 = 5;
        _this.w3 = 0;
        _this.abx = null;
        _this.ab4 = null;
        _this.abv = null;
        _this.abw = null;
        _this.wy = 0;
        _this.xf = 0;
        _this.wx = NaN;
        _this.xe = NaN;
        _this.w0 = NaN;
        _this.xh = NaN;
        _this.wz = NaN;
        _this.xg = NaN;
        _this.ww = NaN;
        _this.xd = NaN;
        _this.ab3 = null;
        _this.aca = null;
        _this.yp = null;
        _this.yt = null;
        _this.yr = null;
        _this.yv = null;
        _this.yk = null;
        _this.yl = null;
        _this.aby = null;
        _this.ab5 = null;
        _this.wq = DeviceUtils.g(1);
        _this.w7 = DeviceUtils.g(1);
        _this.wr = DeviceUtils.g(1);
        _this.w8 = DeviceUtils.g(1);
        _this.ab0 = null;
        _this.ab7 = null;
        _this.ab1 = null;
        _this.ab8 = null;
        _this.ws = DeviceUtils.g(1);
        _this.w9 = DeviceUtils.g(1);
        _this.wt = DeviceUtils.g(8);
        _this.xa = 0;
        _this.ab2 = null;
        _this.ab9 = null;
        _this.wu = DeviceUtils.g(1);
        _this.xb = DeviceUtils.g(1);
        _this.yq = null;
        _this.yu = null;
        _this.abz = null;
        _this.ab6 = null;
        _this.wl = 0;
        _this.w2 = 0;
        _this.wk = NaN;
        _this.w1 = NaN;
        _this.wv = 0;
        _this.xc = -90;
        _this.wg = false;
        _this.wh = false;
        _this.abq = 1;
        _this.act = 1;
        _this.abp = 1;
        _this.abr = 2;
        _this.acr = 0;
        _this.acs = 1;
        _this.acx = 0;
        _this.acy = 0;
        _this.we = 4;
        _this.wc = 4;
        _this.yo = null;
        _this.v0 = null;
        _this.ys = null;
        _this.v1 = null;
        return _this;
    }
    XYChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.v4();
            var c = this.v5();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    XYChart.prototype.r9 = function () {
        _super.prototype.r9.call(this);
        var a = this.v4();
        var b = this.v5();
        if (a != null && a.az != null) {
            this.acd = a.az.textColor;
        }
        if (b != null && b.az != null) {
            this.ack = b.az.textColor;
        }
        this.aci = AxisDefaults.j;
        this.acp = AxisDefaults.j;
        this.ace = AxisDefaults.h;
        this.acl = AxisDefaults.h;
        this.ach = AxisDefaults.g;
        this.aco = AxisDefaults.g;
    };
    XYChart.prototype.sz = function (a, b, c) {
        var _this = this;
        _super.prototype.sz.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.abh(function (d) { return d.leftMargin = _this.xp; });
                break;
            case "XAxisLabelTopMargin":
                this.abh(function (d) { return d.topMargin = _this.xr; });
                break;
            case "XAxisLabelRightMargin":
                this.abh(function (d) { return d.rightMargin = _this.xq; });
                break;
            case "XAxisLabelBottomMargin":
                this.abh(function (d) { return d.bottomMargin = _this.xo; });
                break;
            case "YAxisLabelLeftMargin":
                this.abm(function (d) { return d.leftMargin = _this.x6; });
                break;
            case "YAxisLabelTopMargin":
                this.abm(function (d) { return d.topMargin = _this.x8; });
                break;
            case "YAxisLabelRightMargin":
                this.abm(function (d) { return d.rightMargin = _this.x7; });
                break;
            case "YAxisLabelBottomMargin":
                this.abm(function (d) { return d.bottomMargin = _this.x5; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.acb = this.u7(this.acd);
                this.acc = this.u7(this.ack);
                break;
            case "XAxisLabelTextColor":
                this.acb = this.u7(this.acd);
                break;
            case "YAxisLabelTextColor":
                this.acc = this.u7(this.ack);
                break;
            case "ActualXAxisLabelTextColor":
                this.abh(function (d) { return d.textColor = _this.acb; });
                break;
            case "ActualYAxisLabelTextColor":
                this.abm(function (d) { return d.textColor = _this.acc; });
                break;
            case "XAxisTitleMargin":
                this.abj(function (d) { return d.margin = _this.x0; });
                break;
            case "YAxisTitleMargin":
                this.abo(function (d) { return d.margin = _this.yh; });
                break;
            case "XAxisTitleLeftMargin":
                this.abj(function (d) { return d.leftMargin = _this.xz; });
                break;
            case "YAxisTitleLeftMargin":
                this.abo(function (d) { return d.leftMargin = _this.yg; });
                break;
            case "XAxisTitleTopMargin":
                this.abj(function (d) { return d.topMargin = _this.x2; });
                break;
            case "YAxisTitleTopMargin":
                this.abo(function (d) { return d.topMargin = _this.yj; });
                break;
            case "XAxisTitleRightMargin":
                this.abj(function (d) { return d.rightMargin = _this.x1; });
                break;
            case "YAxisTitleRightMargin":
                this.abo(function (d) { return d.rightMargin = _this.yi; });
                break;
            case "XAxisTitleBottomMargin":
                this.abj(function (d) { return d.bottomMargin = _this.xy; });
                break;
            case "YAxisTitleBottomMargin":
                this.abo(function (d) { return d.bottomMargin = _this.yf; });
                break;
            case "XAxisTitleTextColor":
                this.abj(function (d) { return d.textColor = _this.acj; });
                break;
            case "YAxisTitleTextColor":
                this.abo(function (d) { return d.textColor = _this.acq; });
                break;
            case "XAxisFormatLabel":
                this.abf(function (d) { return d.au = _this.v8; });
                break;
            case "YAxisFormatLabel":
                this.abk(function (d) { return d.au = _this.v9; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "v8", {
        get: function () {
            return this.v6;
        },
        set: function (a) {
            var b = this.v8;
            if (a != b) {
                this.v6 = a;
                this.sw("XAxisFormatLabel", b, this.v8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "v9", {
        get: function () {
            return this.v7;
        },
        set: function (a) {
            var b = this.v9;
            if (a != b) {
                this.v7 = a;
                this.sw("YAxisFormatLabel", b, this.v9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xp", {
        get: function () {
            return this.wn;
        },
        set: function (a) {
            var b = this.xp;
            if (a != b) {
                this.wn = a;
                this.sw("XAxisLabelLeftMargin", b, this.xp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xr", {
        get: function () {
            return this.wp;
        },
        set: function (a) {
            var b = this.xr;
            if (a != b) {
                this.wp = a;
                this.sw("XAxisLabelTopMargin", b, this.xr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xq", {
        get: function () {
            return this.wo;
        },
        set: function (a) {
            var b = this.xq;
            if (a != b) {
                this.wo = a;
                this.sw("XAxisLabelRightMargin", b, this.xq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xo", {
        get: function () {
            return this.wm;
        },
        set: function (a) {
            var b = this.xo;
            if (a != b) {
                this.wm = a;
                this.sw("XAxisLabelBottomMargin", b, this.xo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x6", {
        get: function () {
            return this.w4;
        },
        set: function (a) {
            var b = this.x6;
            if (a != b) {
                this.w4 = a;
                this.sw("YAxisLabelLeftMargin", b, this.x6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x8", {
        get: function () {
            return this.w6;
        },
        set: function (a) {
            var b = this.x8;
            if (a != b) {
                this.w6 = a;
                this.sw("YAxisLabelTopMargin", b, this.x8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x7", {
        get: function () {
            return this.w5;
        },
        set: function (a) {
            var b = this.x7;
            if (a != b) {
                this.w5 = a;
                this.sw("YAxisLabelRightMargin", b, this.x7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x5", {
        get: function () {
            return this.w3;
        },
        set: function (a) {
            var b = this.x5;
            if (a != b) {
                this.w3 = a;
                this.sw("YAxisLabelBottomMargin", b, this.x5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acd", {
        get: function () {
            return this.abx;
        },
        set: function (a) {
            var b = this.acd;
            if (a != b) {
                this.abx = a;
                this.sw("XAxisLabelTextColor", b, this.acd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ack", {
        get: function () {
            return this.ab4;
        },
        set: function (a) {
            var b = this.ack;
            if (a != b) {
                this.ab4 = a;
                this.sw("YAxisLabelTextColor", b, this.ack);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acb", {
        get: function () {
            return this.abv;
        },
        set: function (a) {
            var b = this.abv;
            if (a != b) {
                this.abv = a;
                this.sw("ActualXAxisLabelTextColor", b, this.acb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acc", {
        get: function () {
            return this.abw;
        },
        set: function (a) {
            var b = this.abw;
            if (a != b) {
                this.abw = a;
                this.sw("ActualYAxisLabelTextColor", b, this.acc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x0", {
        get: function () {
            return this.wy;
        },
        set: function (a) {
            var b = this.x0;
            if (a != b) {
                this.wy = a;
                this.sw("XAxisTitleMargin", b, this.x0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yh", {
        get: function () {
            return this.xf;
        },
        set: function (a) {
            var b = this.yh;
            if (a != b) {
                this.xf = a;
                this.sw("YAxisTitleMargin", b, this.yh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xz", {
        get: function () {
            return this.wx;
        },
        set: function (a) {
            var b = this.xz;
            if (a != b) {
                this.wx = a;
                this.sw("XAxisTitleLeftMargin", b, this.xz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yg", {
        get: function () {
            return this.xe;
        },
        set: function (a) {
            var b = this.yg;
            if (a != b) {
                this.xe = a;
                this.sw("YAxisTitleLeftMargin", b, this.yg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x2", {
        get: function () {
            return this.w0;
        },
        set: function (a) {
            var b = this.x2;
            if (a != b) {
                this.w0 = a;
                this.sw("XAxisTitleTopMargin", b, this.x2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yj", {
        get: function () {
            return this.xh;
        },
        set: function (a) {
            var b = this.yj;
            if (a != b) {
                this.xh = a;
                this.sw("YAxisTitleTopMargin", b, this.yj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x1", {
        get: function () {
            return this.wz;
        },
        set: function (a) {
            var b = this.x1;
            if (a != b) {
                this.wz = a;
                this.sw("XAxisTitleRightMargin", b, this.x1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yi", {
        get: function () {
            return this.xg;
        },
        set: function (a) {
            var b = this.yi;
            if (a != b) {
                this.xg = a;
                this.sw("YAxisTitleRightMargin", b, this.yi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xy", {
        get: function () {
            return this.ww;
        },
        set: function (a) {
            var b = this.xy;
            if (a != b) {
                this.ww = a;
                this.sw("XAxisTitleBottomMargin", b, this.xy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yf", {
        get: function () {
            return this.xd;
        },
        set: function (a) {
            var b = this.yf;
            if (a != b) {
                this.xd = a;
                this.sw("YAxisTitleBottomMargin", b, this.yf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acj", {
        get: function () {
            return this.ab3;
        },
        set: function (a) {
            var b = this.acj;
            if (a != b) {
                this.ab3 = a;
                this.sw("XAxisTitleTextColor", b, this.acj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acq", {
        get: function () {
            return this.aca;
        },
        set: function (a) {
            var b = this.acq;
            if (a != b) {
                this.aca = a;
                this.sw("YAxisTitleTextColor", b, this.acq);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.s0 = function (a, b, c) {
        var _this = this;
        _super.prototype.s0.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.abh(function (d) { return d.textStyle = _this.zd; });
                break;
            case "YAxisLabelTextStyle":
                this.abm(function (d) { return d.textStyle = _this.aai; });
                break;
            case "XAxisTitleTextStyle":
                this.abj(function (d) { return d.textStyle = _this.z1; });
                break;
            case "YAxisTitleTextStyle":
                this.abo(function (d) { return d.textStyle = _this.aa6; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "zd", {
        get: function () {
            return this.yp;
        },
        set: function (a) {
            var b = this.zd;
            if (a != b) {
                this.yp = a;
                this.sw("XAxisLabelTextStyle", b, this.zd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aai", {
        get: function () {
            return this.yt;
        },
        set: function (a) {
            var b = this.aai;
            if (a != b) {
                this.yt = a;
                this.sw("YAxisLabelTextStyle", b, this.aai);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "z1", {
        get: function () {
            return this.yr;
        },
        set: function (a) {
            var b = this.z1;
            if (a != b) {
                this.yr = a;
                this.sw("XAxisTitleTextStyle", b, this.z1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa6", {
        get: function () {
            return this.yv;
        },
        set: function (a) {
            var b = this.aa6;
            if (a != b) {
                this.yv = a;
                this.sw("YAxisTitleTextStyle", b, this.aa6);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.abc = function (a) {
        var _this = this;
        this.aa9(a, function (b) { return b.leftMargin = _this.xp; });
        this.aa9(a, function (b) { return b.topMargin = _this.xr; });
        this.aa9(a, function (b) { return b.rightMargin = _this.xq; });
        this.aa9(a, function (b) { return b.bottomMargin = _this.xo; });
        this.aa9(a, function (b) { return b.textColor = _this.acb; });
        this.aba(a, function (b) { return b.textColor = _this.acj; });
        this.aba(a, function (b) { return b.leftMargin = _this.xz; });
        this.aba(a, function (b) { return b.topMargin = _this.x2; });
        this.aba(a, function (b) { return b.rightMargin = _this.x1; });
        this.aba(a, function (b) { return b.bottomMargin = _this.xy; });
        this.aa9(a, function (b) { return b.textStyle = _this.zd; });
        this.aba(a, function (b) { return b.textStyle = _this.z1; });
    };
    XYChart.prototype.abe = function (a) {
        var _this = this;
        this.aa9(a, function (b) { return b.leftMargin = _this.x6; });
        this.aa9(a, function (b) { return b.topMargin = _this.x8; });
        this.aa9(a, function (b) { return b.rightMargin = _this.x7; });
        this.aa9(a, function (b) { return b.bottomMargin = _this.x5; });
        this.aa9(a, function (b) { return b.textColor = _this.acc; });
        this.aba(a, function (b) { return b.textColor = _this.acq; });
        this.aba(a, function (b) { return b.leftMargin = _this.yg; });
        this.aba(a, function (b) { return b.topMargin = _this.yj; });
        this.aba(a, function (b) { return b.rightMargin = _this.yi; });
        this.aba(a, function (b) { return b.bottomMargin = _this.yf; });
        this.aa9(a, function (b) { return b.textStyle = _this.aai; });
        this.aba(a, function (b) { return b.textStyle = _this.aa6; });
    };
    XYChart.prototype.th = function (a) {
        var b = this.bc(a);
        var c = this.c1(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        c.name = this.oe(a);
        c.title = this.of(a, b);
        this.dataChart.series.add(c);
    };
    XYChart.prototype.abf = function (a) {
        this.abg(a, null);
    };
    XYChart.prototype.abg = function (a, b) {
        a(this.v4());
    };
    XYChart.prototype.abl = function (a, b) {
        a(this.v5());
    };
    XYChart.prototype.abk = function (a) {
        this.abl(a, true);
    };
    XYChart.prototype.rt = function (a, b) {
        this.abf(a);
        this.abl(a, b);
    };
    XYChart.prototype.abj = function (a) {
        this.aba(this.v4(), a);
    };
    XYChart.prototype.abo = function (a) {
        this.aba(this.v5(), a);
    };
    XYChart.prototype.abm = function (a) {
        this.aa9(this.v5(), a);
    };
    XYChart.prototype.abh = function (a) {
        this.aa9(this.v4(), a);
    };
    XYChart.prototype.xi = function (a) {
        var b = this.v4();
        return b.ej(a, new ScalerParams(1, this.vf, this.ve, b.ch));
    };
    XYChart.prototype.xk = function (a) {
        var b = this.v4();
        return b.em(a, new ScalerParams(1, this.vf, this.ve, b.ch));
    };
    XYChart.prototype.xj = function (a) {
        var b = this.v5();
        return b.ej(a, new ScalerParams(1, this.vf, this.ve, b.ch));
    };
    XYChart.prototype.xl = function (a) {
        var b = this.v5();
        return b.em(a, new ScalerParams(1, this.vf, this.ve, b.ch));
    };
    XYChart.prototype.te = function (a) {
        _super.prototype.te.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.v4();
            var c = this.v5();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    XYChart.yy = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    XYChart.prototype.r4 = function (a) {
        _super.prototype.r4.call(this, a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.v4());
            this.dataChart.axes.add(this.v5());
        }
    };
    XYChart.prototype.abb = function (a) {
        var _this = this;
        if (a != null && this.j8 != null && a.fl == null) {
            a.provideRenderer(this.j8);
        }
        a.jw = this.ace;
        a.er = this.xs;
        a.jx = this.acf;
        a.eu = this.xt;
        a.jz = this.ach;
        a.fg = this.xu;
        a.jy = this.acg;
        a.fh = this.xv;
        a.j0 = this.aci;
        a.fi = this.xw;
        a.c4 = true;
        a.cu = this.gb;
        a.cw = this.gb;
        var b = a == this.v4();
        if (b) {
            a.g6 = this.zs;
        }
        a.f0 = this.ym;
        a.gg = this.y4;
        a.ah = this.v2;
        this.aa9(a, function (c) { return c.angle = _this.xn; });
        this.aa9(a, function (c) {
            if (c.extent != _this.xm) {
                c.extent = _this.xm;
            }
        });
        this.aa9(a, function (c) { return c.horizontalAlignment = _this.abs; });
        this.aa9(a, function (c) { return c.verticalAlignment = _this.acu; });
        this.aa9(a, function (c) { return c.visibility = _this.acz; });
        this.aa9(a, function (c) { return c.location = _this.wa(_this.wd); });
        this.aba(a, function (c) { return c.horizontalAlignment = _this.abt; });
        this.aba(a, function (c) { return c.angle = _this.xx; });
        this.abc(a);
    };
    XYChart.prototype.abd = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.j8 != null && a.fl == null) {
            a.provideRenderer(this.j8);
        }
        a.cu = this.gb;
        a.cw = this.gb;
        this.aa9(a, function (b) { return b.angle = _this.x4; });
        this.aa9(a, function (b) {
            if (b.extent != _this.x3) {
                b.extent = _this.x3;
            }
        });
        this.aa9(a, function (b) { return b.horizontalAlignment = _this.abu; });
        this.aa9(a, function (b) { return b.verticalAlignment = _this.acv; });
        this.aa9(a, function (b) { return b.visibility = _this.ac0; });
        this.aa9(a, function (b) { return b.location = _this.wb(_this.wf); });
        this.aba(a, function (b) { return b.verticalAlignment = _this.acw; });
        this.aba(a, function (b) { return b.angle = _this.ye; });
        a.jw = this.acl;
        a.er = this.x9;
        a.jx = this.acm;
        a.eu = this.ya;
        a.jz = this.aco;
        a.fg = this.yb;
        a.jy = this.acn;
        a.fh = this.yc;
        a.j0 = this.acp;
        a.fi = this.yd;
        var b = a == this.v5();
        if (b) {
            a.g6 = this.aax;
        }
        a.gg = this.z9;
        a.ah = this.v3;
        this.abe(a);
    };
    XYChart.prototype.r1 = function () {
        _super.prototype.r1.call(this);
        this.abb(this.v4());
        this.abd(this.v5());
    };
    XYChart.prototype.aa9 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.az == null) {
            a.az = new AxisLabelSettings();
            a.az.angle = a.d5();
            a.az.bottomMargin = a.d6();
            a.az.leftMargin = a.d7();
            a.az.rightMargin = a.d8();
            a.az.topMargin = a.d9();
            a.az.horizontalAlignment = a.jr();
            a.az.location = a.a0();
            a.az.verticalAlignment = a.kk();
        }
        b(a.az);
    };
    XYChart.prototype.aba = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.bf == null) {
            a.bf = new TitleSettings();
            a.bf.bottomMargin = a.eb();
            a.bf.leftMargin = a.ec();
            a.bf.rightMargin = a.ed();
            a.bf.topMargin = a.ee();
            a.bf.location = a.a1();
            a.bf.angle = a.ea();
            a.bf.horizontalAlignment = a.js();
            a.bf.verticalAlignment = a.kl();
        }
        b(a.bf);
    };
    XYChart.prototype.sw = function (a, b, c) {
        var _this = this;
        _super.prototype.sw.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.abh(function (d) { return d.angle = _this.xn; });
                break;
            case "YAxisLabelAngle":
                this.abm(function (d) { return d.angle = _this.x4; });
                break;
            case "XAxisLabelHorizontalAlignment":
                this.abh(function (d) { return d.horizontalAlignment = _this.abs; });
                break;
            case "YAxisLabelHorizontalAlignment":
                this.abm(function (d) { return d.horizontalAlignment = _this.abu; });
                break;
            case "XAxisLabelVerticalAlignment":
                this.abh(function (d) { return d.verticalAlignment = _this.acu; });
                break;
            case "YAxisLabelVerticalAlignment":
                this.abm(function (d) { return d.verticalAlignment = _this.acv; });
                break;
            case "XAxisLabelVisibility":
                this.abh(function (d) { return d.visibility = _this.acz; });
                break;
            case "YAxisLabelVisibility":
                this.abm(function (d) { return d.visibility = _this.ac0; });
                break;
            case "XAxisLabel":
                this.abf(function (d) { return d.f0 = _this.ym; });
                break;
            case "YAxisLabel":
                this.abk(function (d) { return d.f0 = _this.yn; });
                break;
            case "XAxisLabelFormat":
                this.abf(function (d) { return d.gg = _this.y4; });
                break;
            case "XAxisLabelFormatSpecifiers":
                this.abf(function (d) { return d.ah = _this.v2; });
                break;
            case "YAxisLabelFormat":
                this.abk(function (d) { return d.gg = _this.z9; });
                break;
            case "YAxisLabelFormatSpecifiers":
                this.abk(function (d) { return d.ah = _this.v3; });
                break;
            case "XAxisTitleAngle":
                this.abj(function (d) { return d.angle = _this.xx; });
                break;
            case "YAxisTitleAngle":
                this.abo(function (d) { return d.angle = _this.ye; });
                break;
            case "XAxisTitleAlignment":
                this.abj(function (d) { return d.horizontalAlignment = _this.abt; });
                break;
            case "YAxisTitleAlignment":
                this.abo(function (d) { return d.verticalAlignment = _this.acw; });
                break;
            case "XAxisTitle":
                this.abf(function (d) { return d.g6 = _this.zs; });
                break;
            case "YAxisTitle":
                this.abl(function (d) { return d.g6 = _this.aax; }, false);
                break;
            case "XAxisMajorStroke":
                this.abg(function (d) { return d.jw = _this.ace; }, a);
                break;
            case "YAxisMajorStroke":
                this.abk(function (d) { return d.jw = _this.acl; });
                break;
            case "XAxisMajorStrokeThickness":
                this.abg(function (d) { return d.er = _this.xs; }, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.abk(function (d) { return d.er = _this.x9; });
                break;
            case "XAxisMinorStroke":
                this.abf(function (d) { return d.jx = _this.acf; });
                break;
            case "YAxisMinorStroke":
                this.abk(function (d) { return d.jx = _this.acm; });
                break;
            case "XAxisMinorStrokeThickness":
                this.abf(function (d) { return d.eu = _this.xt; });
                break;
            case "YAxisMinorStrokeThickness":
                this.abk(function (d) { return d.eu = _this.ya; });
                break;
            case "XAxisTickLength":
                this.abf(function (d) { return d.fh = _this.xv; });
                break;
            case "YAxisTickLength":
                this.abk(function (d) { return d.fh = _this.yc; });
                break;
            case "XAxisTickStroke":
                this.abf(function (d) { return d.j0 = _this.aci; });
                break;
            case "YAxisTickStroke":
                this.abk(function (d) { return d.j0 = _this.acp; });
                break;
            case "XAxisTickStrokeThickness":
                this.abf(function (d) { return d.fi = _this.xw; });
                break;
            case "YAxisTickStrokeThickness":
                this.abk(function (d) { return d.fi = _this.yd; });
                break;
            case "XAxisStroke":
                this.abf(function (d) { return d.jz = _this.ach; });
                break;
            case "YAxisStroke":
                this.abk(function (d) { return d.jz = _this.aco; });
                break;
            case "XAxisStrokeThickness":
                this.abf(function (d) { return d.fg = _this.xu; });
                break;
            case "YAxisStrokeThickness":
                this.abk(function (d) { return d.fg = _this.yb; });
                break;
            case "XAxisExtent":
                this.abh(function (d) { return d.extent = _this.xm; });
                break;
            case "YAxisExtent":
                this.abm(function (d) { return d.extent = _this.x3; });
                break;
            case "XAxisStrip":
                this.abf(function (d) { return d.jy = _this.acg; });
                break;
            case "YAxisStrip":
                this.abk(function (d) { return d.jy = _this.acn; });
                break;
            case "XAxisInverted":
                this.abf(function (d) { return d.ch = _this.wi; });
                break;
            case "YAxisInverted":
                this.abk(function (d) { return d.ch = _this.wj; });
                break;
            case "YAxisLabelLocation":
                this.abn();
                break;
            case "XAxisLabelLocation":
                this.abi();
                break;
        }
    };
    XYChart.prototype.abn = function () {
        var a = this.wb(this.wf);
        if (a == 2 || a == 7) {
            this.abu = 2;
        }
        else {
            this.abu = 0;
        }
        this.abm(function (b) { return b.location = a; });
    };
    XYChart.prototype.abi = function () {
        var a = this.wa(this.wd);
        if (a == 1 || a == 5) {
            this.acu = 0;
        }
        else {
            this.acu = 2;
        }
        this.abh(function (b) { return b.location = a; });
    };
    XYChart.prototype.wb = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.b1 == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    XYChart.prototype.wa = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(XYChart.prototype, "ym", {
        get: function () {
            return this.yk;
        },
        set: function (a) {
            var b = this.ym;
            if (a != b) {
                this.yk = a;
                this.sw("XAxisLabel", b, this.ym);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yn", {
        get: function () {
            return this.yl;
        },
        set: function (a) {
            var b = this.yn;
            if (a != b) {
                this.yl = a;
                this.sw("YAxisLabel", b, this.yn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ace", {
        get: function () {
            return this.aby;
        },
        set: function (a) {
            var b = this.ace;
            if (a != b) {
                this.aby = a;
                this.sw("XAxisMajorStroke", b, this.ace);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acl", {
        get: function () {
            return this.ab5;
        },
        set: function (a) {
            var b = this.acl;
            if (a != b) {
                this.ab5 = a;
                this.sw("YAxisMajorStroke", b, this.acl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xs", {
        get: function () {
            return this.wq;
        },
        set: function (a) {
            var b = this.xs;
            if (a != b) {
                this.wq = a;
                this.sw("XAxisMajorStrokeThickness", b, this.xs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x9", {
        get: function () {
            return this.w7;
        },
        set: function (a) {
            var b = this.x9;
            if (a != b) {
                this.w7 = a;
                this.sw("YAxisMajorStrokeThickness", b, this.x9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xt", {
        get: function () {
            return this.wr;
        },
        set: function (a) {
            var b = this.xt;
            if (a != b) {
                this.wr = a;
                this.sw("XAxisMinorStrokeThickness", b, this.xt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ya", {
        get: function () {
            return this.w8;
        },
        set: function (a) {
            var b = this.ya;
            if (a != b) {
                this.w8 = a;
                this.sw("YAxisMinorStrokeThickness", b, this.ya);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acg", {
        get: function () {
            return this.ab0;
        },
        set: function (a) {
            var b = this.acg;
            if (a != b) {
                this.ab0 = a;
                this.sw("XAxisStrip", b, this.acg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acn", {
        get: function () {
            return this.ab7;
        },
        set: function (a) {
            var b = this.acn;
            if (a != b) {
                this.ab7 = a;
                this.sw("YAxisStrip", b, this.acn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ach", {
        get: function () {
            return this.ab1;
        },
        set: function (a) {
            var b = this.ach;
            if (a != b) {
                this.ab1 = a;
                this.sw("XAxisStroke", b, this.ach);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aco", {
        get: function () {
            return this.ab8;
        },
        set: function (a) {
            var b = this.aco;
            if (a != b) {
                this.ab8 = a;
                this.sw("YAxisStroke", b, this.aco);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xu", {
        get: function () {
            return this.ws;
        },
        set: function (a) {
            var b = this.xu;
            if (a != b) {
                this.ws = a;
                this.sw("XAxisStrokeThickness", b, this.xu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yb", {
        get: function () {
            return this.w9;
        },
        set: function (a) {
            var b = this.yb;
            if (a != b) {
                this.w9 = a;
                this.sw("YAxisStrokeThickness", b, this.yb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xv", {
        get: function () {
            return this.wt;
        },
        set: function (a) {
            var b = this.xv;
            if (a != b) {
                this.wt = a;
                this.sw("XAxisTickLength", b, this.xv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yc", {
        get: function () {
            return this.xa;
        },
        set: function (a) {
            var b = this.yc;
            if (a != b) {
                this.xa = a;
                this.sw("YAxisTickLength", b, this.yc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aci", {
        get: function () {
            return this.ab2;
        },
        set: function (a) {
            var b = this.aci;
            if (a != b) {
                this.ab2 = a;
                this.sw("XAxisTickStroke", b, this.aci);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acp", {
        get: function () {
            return this.ab9;
        },
        set: function (a) {
            var b = this.acp;
            if (a != b) {
                this.ab9 = a;
                this.sw("YAxisTickStroke", b, this.acp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xw", {
        get: function () {
            return this.wu;
        },
        set: function (a) {
            var b = this.xw;
            if (a != b) {
                this.wu = a;
                this.sw("XAxisTickStrokeThickness", b, this.xw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yd", {
        get: function () {
            return this.xb;
        },
        set: function (a) {
            var b = this.yd;
            if (a != b) {
                this.xb = a;
                this.sw("YAxisTickStrokeThickness", b, this.yd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zs", {
        get: function () {
            return this.yq;
        },
        set: function (a) {
            var b = this.zs;
            if (a != b) {
                this.yq = a;
                this.sw("XAxisTitle", b, this.zs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aax", {
        get: function () {
            return this.yu;
        },
        set: function (a) {
            var b = this.aax;
            if (a != b) {
                this.yu = a;
                this.sw("YAxisTitle", b, this.aax);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acf", {
        get: function () {
            return this.abz;
        },
        set: function (a) {
            var b = this.acf;
            if (a != b) {
                this.abz = a;
                this.sw("XAxisMinorStroke", b, this.acf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acm", {
        get: function () {
            return this.ab6;
        },
        set: function (a) {
            var b = this.acm;
            if (a != b) {
                this.ab6 = a;
                this.sw("YAxisMinorStroke", b, this.acm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xn", {
        get: function () {
            return this.wl;
        },
        set: function (a) {
            var b = this.xn;
            if (a != b) {
                this.wl = a;
                this.sw("XAxisLabelAngle", b, this.xn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x4", {
        get: function () {
            return this.w2;
        },
        set: function (a) {
            var b = this.x4;
            if (a != b) {
                this.w2 = a;
                this.sw("YAxisLabelAngle", b, this.x4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xm", {
        get: function () {
            return this.wk;
        },
        set: function (a) {
            var b = this.xm;
            if (a != b) {
                this.wk = a;
                this.sw("XAxisExtent", b, this.xm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x3", {
        get: function () {
            return this.w1;
        },
        set: function (a) {
            var b = this.x3;
            if (a != b) {
                this.w1 = a;
                this.sw("YAxisExtent", b, this.x3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xx", {
        get: function () {
            return this.wv;
        },
        set: function (a) {
            var b = this.xx;
            if (a != b) {
                this.wv = a;
                this.sw("XAxisTitleAngle", b, this.xx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ye", {
        get: function () {
            return this.xc;
        },
        set: function (a) {
            var b = this.ye;
            if (a != b) {
                this.xc = a;
                this.sw("YAxisTitleAngle", b, this.ye);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "wi", {
        get: function () {
            return this.wg;
        },
        set: function (a) {
            var b = this.wi;
            if (a != b) {
                this.wg = a;
                this.sw("XAxisInverted", b, this.wi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "wj", {
        get: function () {
            return this.wh;
        },
        set: function (a) {
            var b = this.wj;
            if (a != b) {
                this.wh = a;
                this.sw("YAxisInverted", b, this.wj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abt", {
        get: function () {
            return this.abq;
        },
        set: function (a) {
            var b = this.abt;
            if (a != b) {
                this.abq = a;
                this.sw("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abt));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acw", {
        get: function () {
            return this.act;
        },
        set: function (a) {
            var b = this.acw;
            if (a != b) {
                this.act = a;
                this.sw("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acw));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abs", {
        get: function () {
            return this.abp;
        },
        set: function (a) {
            var b = this.abs;
            if (a != b) {
                this.abp = a;
                this.sw("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abs));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_abu = function () {
        return this.abr;
    };
    XYChart.prototype.set_abu = function (a) {
        var b = this.abu;
        if (a != b) {
            this.abr = a;
            this.sw("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abu));
        }
    };
    Object.defineProperty(XYChart.prototype, "abu", {
        get: function () {
            return this.get_abu();
        },
        set: function (a) {
            this.set_abu(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acu", {
        get: function () {
            return this.acr;
        },
        set: function (a) {
            var b = this.acu;
            if (a != b) {
                this.acr = a;
                this.sw("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acu));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acv", {
        get: function () {
            return this.acs;
        },
        set: function (a) {
            var b = this.acv;
            if (a != b) {
                this.acs = a;
                this.sw("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acv));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acz", {
        get: function () {
            return this.acx;
        },
        set: function (a) {
            var b = this.acz;
            if (a != b) {
                this.acx = a;
                this.sw("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.acz));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ac0", {
        get: function () {
            return this.acy;
        },
        set: function (a) {
            var b = this.ac0;
            if (a != b) {
                this.acy = a;
                this.sw("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ac0));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_wf = function () {
        return this.we;
    };
    XYChart.prototype.set_wf = function (a) {
        var b = this.wf;
        if (a != b) {
            this.we = a;
            this.sw("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.wf));
        }
    };
    Object.defineProperty(XYChart.prototype, "wf", {
        get: function () {
            return this.get_wf();
        },
        set: function (a) {
            this.set_wf(a);
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_wd = function () {
        return this.wc;
    };
    XYChart.prototype.set_wd = function (a) {
        var b = this.wd;
        if (a != b) {
            this.wc = a;
            this.sw("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.wd));
        }
    };
    Object.defineProperty(XYChart.prototype, "wd", {
        get: function () {
            return this.get_wd();
        },
        set: function (a) {
            this.set_wd(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "y4", {
        get: function () {
            return this.yo;
        },
        set: function (a) {
            var b = this.yo;
            if (a != b) {
                this.yo = a;
                this.sw("XAxisLabelFormat", b, this.yo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "v2", {
        get: function () {
            return this.v0;
        },
        set: function (a) {
            var b = this.v0;
            if (a != b) {
                this.v0 = a;
                this.sw("XAxisLabelFormatSpecifiers", b, this.v0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "z9", {
        get: function () {
            return this.ys;
        },
        set: function (a) {
            var b = this.ys;
            if (a != b) {
                this.ys = a;
                this.sw("YAxisLabelFormat", b, this.ys);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "v3", {
        get: function () {
            return this.v1;
        },
        set: function (a) {
            var b = this.v1;
            if (a != b) {
                this.v1 = a;
                this.sw("YAxisLabelFormatSpecifiers", b, this.v1);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
}(DomainChart));
export { XYChart };
